<?php

/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/

define('GRAPHTYPE', 'linegraph');

$dates = array();
if ($_POST['startu']) {
	$start = $_POST['startu'];
	$end = $_POST['endu'];
	$dates['timing'] = $_POST['timing'];
	$dates['graph'] = $_POST['graph'];
} elseif ($_POST['start']) {
	$start = date('U', mktime(0,0,1,$_POST['start']['month'],$_POST['start']['day'],$_POST['start']['year']));
	$end = date('U', mktime(0,0,1,$_POST['end']['month'],$_POST['end']['day'],$_POST['end']['year']));
	$dates['timing'] = $_POST['timing'];
	$dates['graph'] = $_POST['graph'];
} else {
	$start = ULAST_MONTH;
	$end = UNOW;
	$dates['timing'] = 'daily';
	$dates['graph'] = '1';
}

$dates['start'] = array('day' => date('d', $start), 'month' => date('m', $start), 'year' => date('Y', $start));
$dates['end'] = array('day' => date('d', $end), 'month' => date('m', $end), 'year' => date('Y', $end));

$days = array();
for ($x=1; $x < 32; $x++) {
	$id =date('d', mktime(0,0,1,1,$x,2004));
	$day =date('jS', mktime(0,0,1,1,$x,2004));
	$days[] = array('id' => $id, 'text' => $day);
}

$months = array();
for ($x=1; $x < 13; $x++) {
	$id =date('m', mktime(0,0,1,$x,2,2004));
	$month =date('F', mktime(0,0,1,$x,2,2004));
	$months[] = array('id' => $id, 'text' => $month);
}

$years = array();
for ($x=2002; $x <= NOW_YEAR; $x++) {
	$years[] = array('id' => $x, 'text' => $x);
}

define('HEADING_TITLE', 'Date Ranges');

$from = " from " . DB_PREFIX . "orders o, " . DB_PREFIX . "orders_products op, " . DB_PREFIX . "orders_total total";
$where = " where total.class = 'ot_total' and total.orders_id = o.orders_id and op.orders_id = o.orders_id and o.orders_status != 5" . 
		 " and o.date_purchased >= '" . date(DATE_FORMAT_START, $start) . "' and o.date_purchased <= '" . date(DATE_FORMAT_END, $end) . "'";

$total = shop_db_fetch_array(shop_db_query("select sum(total.value) as total" . $from . $where));

$select = "select sum(@ot_total:=total.value), sum(total.value) as total," .
		  "sum(round((@ot_total / '" . $total['total'] . "') * 100)) as percentage," .
		  "sum(round(op.final_price / op.products_quantity) - op.products_cost) as profit";

switch ($dates['timing']) {
	case 'hourly':
		$select .= ", @name:='', date_format(o.date_purchased, '%H') as short_name,";
		$select .= "IF(HOUR(o.date_purchased) between 0 and 12, @name:='Morning', ''),";
		$select .= "IF(HOUR(o.date_purchased) between 12 and 17, @name:='Afternoon', ''),";
		$select .= "IF(HOUR(o.date_purchased) between 17 and 21, @name:='Evening', ''),";
		$select .= "IF(HOUR(o.date_purchased) between 21 and 23, @name:='Night', ''),";
		$select .= "@name as name";
		$group = " group by name order by HOUR(o.date_purchased)";
		define('TABLE_HEADING_DATE', 'Hours');
		break;
	case 'daily':
		$select .= ", date_format(o.date_purchased, '%d') as short_name";
		$select .= ", date_format(o.date_purchased, '%W, %M %D, %Y') as name";
		$group = " group by DAYOFYEAR(o.date_purchased), YEAR(o.date_purchased) order by o.date_purchased";
		define('TABLE_HEADING_DATE', 'Days');
		break;
	case 'weekly':
		$select .= ", date_format(o.date_purchased, '%V') as short_name";
		$select .= ", date_format(o.date_purchased, 'Week of %W %M %D, %Y') as name";
		$group = " group by WEEK(o.date_purchased), YEAR(o.date_purchased) order by o.date_purchased";
		define('TABLE_HEADING_DATE', 'Weeks');
		break;
	case 'monthly':
		$select .= ", date_format(o.date_purchased, '%b') as short_name";
		$select .= ", date_format(o.date_purchased, '%M %Y') as name";
		$group = " group by MONTH(o.date_purchased), YEAR(o.date_purchased) order by o.date_purchased";
		define('TABLE_HEADING_DATE', 'Months');
		break;
	case 'quarterly':
		$select .= ", (sum(11)) as short_name";
		$select .= ", CONCAT('Quarter ', QUARTER(o.date_purchased), ' in ', YEAR(o.date_purchased)) as name";
		$group = " group by QUARTER(o.date_purchased), YEAR(o.date_purchased) order by o.date_purchased";
		define('TABLE_HEADING_DATE', 'Months');
		break;
}

$headers = array(0 => array('align' => 'left', 'text' => TABLE_HEADING_DATE, 'bg' => 'column'),
				 1 => array('align' => 'center', 'text' => TABLE_HEADING_PURCHASED, 'bg' => ($dates['graph'] == 1) ? 'col_selected' : 'column'),
				 2 => array('align' => 'center', 'text' => TABLE_HEADING_PROFIT, 'bg' => ($dates['graph'] == 2) ? 'col_selected' : 'column'));
				
$columns = array(0 => array('align' => 'left', 'text' => 'name'),
				 1 => array('align' => 'right', 'text' => 'total', 'function' => '$currencies->format('),
				 2 => array('align' => 'right', 'text' => 'profit', 'function' => '$currencies->format('));
				
$footers = array(0 => array('align' => 'left', 'text' => 'Total'),
				 1 => array('align' => 'right', 'text' => '0', 'function' => '$currencies->format('),
				 2 => array('align' => 'right', 'text' => '0', 'function' => '$currencies->format('));

$query = $select . $from . $where . $group;

list($stats, $nodata, $data_array) = shop_simple_date_graph($headers, $columns, $footers, $query, 4);

$data = $data_array[$dates['graph']];

$graph = array();
$graph[] = array('id' => '1', 'text' => 'Sales');
$graph[] = array('id' => '2', 'text' => 'Gross Profits');

$timings = array();
$timings[] = array('id' => 'hourly', 'text' => 'Hourly');
$timings[] = array('id' => 'daily', 'text' => 'Daily');
$timings[] = array('id' => 'weekly', 'text' => 'Weekly');
$timings[] = array('id' => 'monthly', 'text' => 'Monthly');
$timings[] = array('id' => 'quarterly', 'text' => 'Quarterly');

$stats .= shop_draw_form('date_range', MYSELF, 'type=ranges', 'post');
$stats .= '<tr><td colspan="' . (sizeof($columns)+1) . '"></td></tr>';

$stats .= '<tr class="dataTableRow"><td class="dataTableContent" colspan="' . (sizeof($columns)+1) . '" align="right">';
$stats .= '<b>Start Date:</b> &nbsp;';
$stats .= shop_draw_pull_down_menu('start[day]', $days, $dates['start']['day']);
$stats .= shop_draw_pull_down_menu('start[month]', $months, $dates['start']['month']);
$stats .= shop_draw_pull_down_menu('start[year]', $years, $dates['start']['year']) . ' &nbsp; </td></tr>';

$stats .= '<tr class="dataTableRow"><td class="dataTableContent" colspan="' . (sizeof($columns)+1) . '" align="right">';
$stats .= '&nbsp; <b>End Date:</b> &nbsp;';
$stats .= shop_draw_pull_down_menu('end[day]', $days, $dates['end']['day']);
$stats .= shop_draw_pull_down_menu('end[month]', $months, $dates['end']['month']);
$stats .= shop_draw_pull_down_menu('end[year]', $years, $dates['end']['year']) . ' &nbsp; </td></tr>';

$stats .= '<tr class="dataTableRow"><td class="dataTableContent" colspan="' . (sizeof($columns)+1) . '" align="right">';
$stats .= '<b>Graph:</b> &nbsp;';
$stats .= shop_draw_pull_down_menu('graph', $graph, $dates['graph']);
$stats .= shop_draw_pull_down_menu('timing', $timings, $dates['timing']) . ' &nbsp; </td></tr>';

$stats .= '<tr class="dataTableRow"><td class="dataTableContent" colspan="' . (sizeof($columns)+1) . '" align="right">';
$stats .= shop_image_submit('button_update.gif') . ' &nbsp; </td></tr>';
$stats .= '</form>';
