<?php

/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/

define('HEADING_TITLE', 'World Regions');
define('TABLE_HEADING_REGION', 'Regions');
define('GRAPHTYPE', 'worldmap');

$europe = array('Albania', 'Andorra', 'Austria', 'Belarus', 'Belgium', 'Bosnia', 'Bulgaria', 'Croatia', 'Cyprus', 'Czech Republic', 'Denmark', 'Estonia', 'Finland', 'France', 'Germany', 'Greece', 'Hungary', 'Iceland', 'Ireland', 'Italy', 'Latvia', 'Liechtenstein', 'Lithuania', 'Luxembourg', 'Macedonia', 'Malta', 'Moldova', 'Monaco', 'Netherlands', 'Norway', 'Poland', 'Portugal', 'Romania', 'Russia', 'San Marino', 'Slovakia (Slovak Republic)', 'Slovenia', 'Spain', 'Sweden', 'Switzerland', 'Ukraine', 'United Kingdom', 'Vatican City');
$africa = array('Algeria', 'Angola', 'Benin', 'Botswana', 'Burkina Faso', 'Burundi', 'Cameroon', 'Cape Verde', 'Central African Republic', 'Chad', 'Comoros', 'Congo', 'Cote %Ivoire', 'Djibouti', 'Egypt', 'Equatorial Guinea', 'Eritrea', 'Ethiopia', 'Gabon', 'Gambia', 'Ghana', 'Guinea', 'Guinea-Bissau', 'Kenya', 'Lesotho', 'Liberia', 'Libya', 'Madagascar', 'Malawi', 'Mali', 'Mauritania', 'Mauritius', 'Morocco', 'Mozambique', 'Namibia', 'Niger', 'Nigeria', 'Rwanda', 'Sao Tome and Principe', 'Senegal', 'Seychelles', 'Sierra Leone', 'Somalia', 'South Africa', 'Sudan', 'Swaziland', 'Tanzania', 'Togo', 'Tunisia', 'Uganda', 'Zambia', 'Zimbabwe');
$oceania = array('Australia', 'Fiji', 'Kiribati', 'Marshall Islands', 'Micronesia', 'Nauru', 'New Zealand', 'Palau', 'Papua New Guinea', 'Samoa', 'Solomon Islands', 'Tonga', 'Tuvalu', 'Vanuatu');
$asia = array('Afghanistan', 'Armenia', 'Azerbaijan', 'Bahrain', 'Bangladesh', 'Bhutan', 'Brunei', 'Myanmar', 'Cambodia', 'China', 'Egypt', 'Georgia', 'Hong Kong', 'India', 'Indonesia', 'Iran', 'Iraq', 'Israel', 'Japan', 'Jordan', 'Korea, Republic of', "Korea, Democratic People\'s Republic of", 'Kuwait', 'Kyrgyzstan', 'Lebanon', 'Malaysia', 'Maldives', 'Mongolia', 'Myanmar', 'Nepal', 'Oman', 'Pakistan', 'Philippines', 'Qatar', 'Russia', 'Saudi Arabia', 'Singapore', 'Sri Lanka', 'Syria', 'Taiwan', 'Tajikistan', 'Thailand', 'Turkey', 'Turkmenistan', 'United Arab Emirates', 'Uzbekistan', 'Yemen');
$north_america = array('Antigua and Barbuda', 'Barbados', 'Belize', 'Canada', 'Costa Rica', 'Cuba', 'Dominica', 'Dominican Republic', 'El Salvador', 'Greenland', 'Grenada', 'Guatemala', 'Haiti', 'Honduras', 'Iceland', 'Jamaica', 'Mexico', 'Nicaragua', 'Panama', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Vincent and the Grenadines', 'Bahamas', 'Trinidad and Tobago', 'United States');
$south_america = array('Argentina', 'Bolivia', 'Brazil', 'Chile', 'Colombia', 'Ecuador', 'French Guiana', 'Guyana', 'Paraguay', 'Peru', 'Suriname', 'Uruguay', 'Venezuela');
$everywhere = array_merge($europe, $africa, $oceania, $asia, $north_america, $south_america);

$regions = array('europe' => array('ordersum' => 0, 'realname' => 'Europe'), 'africa' => array('ordersum' => 0, 'realname' => 'Africa'), 'oceania' => array('ordersum' => 0, 'realname' => 'Oceania'), 'asia' => array('ordersum' => 0, 'realname' => 'Asia'), 'north_america' => array('ordersum' => 0, 'realname' => 'North America'), 'south_america' => array('ordersum' => 0, 'realname' => 'South America'), 'other' => array('ordersum' => 0, 'realname' => 'Other'));

$countries_query_raw = "select o.customers_country, o.currency, sum(op.products_quantity * op.final_price) as ordersum, sum(op.products_quantity * op.products_cost) as cost from " . DB_PREFIX . "customers c, " . DB_PREFIX . "orders_products op, " . DB_PREFIX . "orders o where o.orders_status != 5 and c.customers_id = o.customers_id and o.orders_id = op.orders_id group by o.customers_country";
$countries_query = shop_db_query($countries_query_raw);
$currencies = new currencies();
$stats = '              <tr>';
$stats .= '                <td height="17" valign="center" class="dataTableContent" background="images/win_header_column.gif"></td>';
$stats .= '                <td height="17" valign="center" class="dataTableContent" background="images/win_header_column.gif" onmouseover="this.style.cursor=\'pointer\';"> &nbsp;' . TABLE_HEADING_REGION . '</td>';
$stats .= '                <td height="17" valign="center" class="dataTableContent" background="images/win_header_col_selected.gif" align="center" onmouseover="this.style.cursor=\'pointer\';">' . TABLE_HEADING_PURCHASED . '</td>';
$stats .= '                <td height="17" valign="center" class="dataTableContent" background="images/win_header_column.gif" align="center" onmouseover="this.style.cursor=\'pointer\';">' . TABLE_HEADING_COST . '</td>';
$stats .= '              </tr>';
$slice_number = 0;
$colornumber = 0;
$total_viewed = 0;
$total_ordered = 0;
$total_cost = 0;
$data = '';
$prod_stat = array();
while ($countries = shop_db_fetch_array($countries_query)) {
  $ordered = $countries['ordersum'];
  $cost = $countries['cost'];
  if ($ordered < 1) $ordered = 0;
  
  if (in_array($countries['customers_country'], $europe)) {
	$regions['europe']['ordersum'] += $ordered;
	$regions['europe']['cost'] += $cost;
  }
  if (in_array($countries['customers_country'], $africa)) {
	$regions['africa']['ordersum'] += $ordered;
	$regions['africa']['cost'] += $cost;
  }
  if (in_array($countries['customers_country'], $oceania)) {
	$regions['oceania']['ordersum'] += $ordered;
	$regions['oceania']['cost'] += $cost;
  }
  if (in_array($countries['customers_country'], $asia)) {
	$regions['asia']['ordersum'] += $ordered;
	$regions['asia']['cost'] += $cost;
  }
  if (in_array($countries['customers_country'], $north_america)) {
	$regions['north_america']['ordersum'] += $ordered;
	$regions['north_america']['cost'] += $cost;
  }
  if (in_array($countries['customers_country'], $south_america)) {
	$regions['south_america']['ordersum'] += $ordered;
	$regions['south_america']['cost'] += $cost;
  }
  if (!in_array($countries['customers_country'], $everywhere)) {
	$regions['other']['ordersum'] += $ordered;
	$regions['other']['cost'] += $cost;
  }
}

// Obtain a list of columns, to sort by
foreach ($regions as $key => $row) {
	$ordersum[$key] = $row['ordersum'];
	$realname[$key] = $row['realname'];
}
array_multisort($ordersum, SORT_DESC, $realname, SORT_ASC, $regions);

#asort($regions, SORT_NUMERIC);
while ($region = each($regions)) {
  $key = $region['key'];
  $value = $region['value']['ordersum'];
  $cost = $region['value']['cost'];
  $name = $region['value']['realname'];
  $ordered = $value;
  if ($ordered < 1) continue;

  if ($colornumber > sizeof($colors)) $colornumber = 0;
  $stats .= '              <tr class="dataTableRow" onmouseover="this.style.cursor=\'pointer\';" height="17" bgcolor="' . $colors[$colornumber] . '">';
  $stats .= '                <td class="dataTableContent" onmouseover="this.style.cursor=\'pointer\';" width="38" bgcolor="' . $colors[$colornumber] . '" align="right" valign="center" height="17">statx' . $key . 'x&nbsp;</td>';
  $stats .= '                <td class="dataTableContent" onmouseover="this.style.cursor=\'pointer\';" bgcolor="' . $colors[$colornumber] . '" align="left" valign="center"> &nbsp;' . $name . '</td>';
  $stats .= '                <td class="dataTableContent" onmouseover="this.style.cursor=\'pointer\';" width="70" bgcolor="' . $colors[$colornumber] . '" align="right" valign="center">' . $currencies->format($value) . ' &nbsp;</td>';
  $stats .= '                <td class="dataTableContent" onmouseover="this.style.cursor=\'pointer\';" width="70" bgcolor="' . $colors[$colornumber] . '" align="right" valign="center">' . $currencies->format($cost) . ' &nbsp;</td>';
  $stats .= '              </tr>';


  $data .= 'data[' . $key . ']=' . $colors[$colornumber] . '&';
  $prod_stat[$key] =  $ordered;
  $slice_number ++;
  $colornumber ++;
  $total_ordered += $ordered;
  $total_cost += $cost;
}
$jpgraphimage = DIR_WS_ADMIN . 'contents/worldmap.php?' . $data;

while (list($key,$value) = each($prod_stat)) {
  $stats = str_replace(('statx' . $key . 'x'), round($value / $total_ordered * 100) . '%', $stats);
}

$focus = '\'jpgraphimage\'';
$onclick = 'onmouseover="this.style.cursor=\'pointer\'; document.jpgraph.src=\'jpgraphimage\'"';
$stats .= '              <tr class="dataTableRow" height="17" ' . $onclick . ' bgcolor="c8c8c8">';
$stats .= '                <td class="dataTableContent" bgcolor="c8c8c8" ' . $onclick . ' align="right" valign="center" height="17">100%&nbsp;</td>';
$stats .= '                <td class="dataTableContent" bgcolor="c8c8c8" ' . $onclick . ' align="left" valign="center"> &nbsp;Total</td>';
$stats .= '                <td class="dataTableContent" bgcolor="c8c8c8" ' . $onclick . ' align="right" valign="center" height="17">' . $currencies->format($total_ordered) . ' &nbsp;</td>';
$stats .= '                <td class="dataTableContent" bgcolor="c8c8c8" ' . $onclick . ' align="right" valign="center" height="17">' . $currencies->format($total_cost) . ' &nbsp;</td>';
$stats .= '              </tr>';

$stats = str_replace(array('jpgraphimage','[',']'), array($jpgraphimage,'%5B','%5D'), $stats);
