<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

  class ot_highorderdiscount {
	var $title, $output;

	function ot_highorderdiscount() {
	  $this->code = 'ot_highorderdiscount';
	  $this->title = 'Discount';
	  $this->description = 'High Order Discount Options:';
	  $this->enabled = defined('MODULE_ORDER_TOTAL_HIGHORDERDISCOUNT_STATUS');
	  $this->sort_order = 6;

	  $this->output = array();
	}

	function process() {
	  global $order;
	  switch (MODULE_ORDER_TOTAL_HIGHORDERDISCOUNT_DESTINATION) {
	    case 'national':
	      if ($order->delivery['country_id'] == STORE_COUNTRY_ID) $pass = true; break;
	    case 'both':
	    case 'international':
	      $pass = true; break;
	    default:
	      $pass = false; break;
	  }
	  
	  $table_discount = split("[:;]" , MODULE_ORDER_TOTAL_HIGHORDERDISCOUNT_DISCOUNT);

		for ($i=0; $i<count($table_discount)/2; $i++) {
			$j = $i * 2;
			if (($order->info['total'] - $order->info['shipping_cost']) >= $table_discount[$j]) {
				$discount = $table_discount[$j+1];
			}
		}
	  
		// convert if discount is a percentage
	  if (substr($discount,-1,1) == '%') {
	      $discount = ($order->info['total'] - $order->info['shipping_cost']) - (($order->info['total'] - $order->info['shipping_cost']) * ((100 - (str_replace('%','',$discount))) / 100));
	  }
	  if ( $pass == true && $discount > 0) {
	    $tax = shop_get_tax_rate(MODULE_ORDER_TOTAL_HIGHORDERDISCOUNT_TAX_CLASS);
	    $order->info['tax'] -= shop_calculate_tax($discount, $tax);
	    $order->info['tax_groups']["{$tax}"] -= shop_calculate_tax($discount, $tax);
	    $order->info['total'] -= $discount + shop_calculate_tax($discount, $tax);
	    $this->output[] = array('title' => $this->title . ':',
	                            'text' => "-" . $GLOBALS['currencies']->format(shop_add_tax($discount, $tax), true, $order->info['currency'], $order->info['currency_value']),
	                            'value' => shop_add_tax($discount, $tax));
	  }
	}

	function check() {
	  return defined('MODULE_ORDER_TOTAL_HIGHORDERDISCOUNT_STATUS');
	}

	function keys() {
	  return array('MODULE_ORDER_TOTAL_HIGHORDERDISCOUNT_STATUS', 'MODULE_ORDER_TOTAL_HIGHORDERDISCOUNT_DISCOUNT', 'MODULE_ORDER_TOTAL_HIGHORDERDISCOUNT_DESTINATION', 'MODULE_ORDER_TOTAL_HIGHORDERDISCOUNT_TAX_CLASS');
	}

	function install() {
		$i = 1;
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_ORDER_TOTAL_HIGHORDERDISCOUNT_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Order Discount', 'MODULE_ORDER_TOTAL_HIGHORDERDISCOUNT_DISCOUNT', '25:0;50:10%;100:15', 'High order discount example:<br />25:0;50:10%;100:15<br />up to $25 no discount, from $25 to $50 discount 10%, from $50 to $100 discount $15.', '6', '" . ($i++) . "', 'shop_cfg_textarea(', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Apply to Orders Made', 'MODULE_ORDER_TOTAL_HIGHORDERDISCOUNT_DESTINATION', 'international', 'Attach high order discount for orders sent to the following destination.', '6', '" . ($i++) . "', 'shop_cfg_select_option(array(\'national\', \'international\', \'both\'), ', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Tax Class', 'MODULE_ORDER_TOTAL_HIGHORDERDISCOUNT_TAX_CLASS', '0', 'Use the following tax class on the high order discount.', '6', '" . ($i++) . "', 'shop_get_tax_class_title', 'shop_cfg_pull_down_tax_classes(', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key in ('" . implode("','", $this->keys()) . "')");
	}
}
