<?php
/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/
  
  class eway {
	var $code, $title, $description, $enabled;

	function eway() {
	  $this->code = 'eway';
	  $this->title = 'eWAY';
	  $this->shop_title = MODULE_PAYMENT_CC_TEXT_TITLE;
	  $this->description = '';
	  $this->signup = 'http://www.eway.com.au/';
	  $this->enabled = defined('MODULE_PAYMENT_EWAY_STATUS');
	  $this->recommend_level = 5;
	  $this->version = "2.0";
	}

	function javascript_validation() {
	  return shop_draw_cc_javascript_validation($this->code);
	}

	function selection() {
	  return shop_draw_cc_input();
	}

	function pre_confirmation_check() {
	  if ($_POST['payment_selected'] == $this->code) shop_validate_cc($_POST['cc_owner'],$_POST['cc_number'], $_POST['cc_expires_month'], $_POST['cc_expires_year'], $_POST['cc_code']);
	}

	function confirmation() {
	  return false;
	}

	function process_button() {
	  $process_button_string = shop_draw_hidden_field('cc_owner', $_POST['cc_owner']) . 
	                           shop_draw_hidden_field('cc_number', $_POST['cc_number']) . 
	                           shop_draw_hidden_field('cc_code', $_POST['cc_code']) . UNIX_RETURN .
	                           shop_draw_hidden_field('cc_expires_month', $_POST['cc_expires_month']) . UNIX_RETURN .
	                           shop_draw_hidden_field('cc_expires_year', $_POST['cc_expires_year']) . UNIX_RETURN;

	  return $process_button_string;
	}

	function before_process() {
	  global $order;
	  
	  $eway_url = 'https://www.eway.com.au/gateway/xmlpayment.asp';
	  
	  $keys = array('ewayCustomerID' => MODULE_PAYMENT_EWAY_MERCHANT_ID,
					'ewayTotalAmount' => round($order->info['total'] * 100),
					'ewayCustomerFirstName' => $order->customer['firstname'],
					'ewayCustomerLastName' => $order->customer['lastname'],
					'ewayCustomerEmail' => $order->customer['email_address'],
					'ewayCustomerAddress' => $order->customer['street_address'],
					'ewayCustomerPostcode' => $order->customer['postcode'],
					'ewayCustomerInvoiceDescription' => STORE_NAME,
					'ewayCustomerInvoiceRef' => $order->info['orders_id'],
					'ewayCardHoldersName' => $_POST['cc_owner'],
					'ewayCardNumber' => $_POST['cc_owner'],
					'ewayCardExpiryMonth' => $_POST['cc_expires_month'],
					'ewayCardExpiryYear' => $_POST['cc_expires_year'],
					'ewayTrxnNumber' => '',
					'ewayOption1' => '',
					'ewayOption2' => '',
					'ewayOption3' => '');

	  $xml = UNIX_RETURN . '<ewaygateway>' . UNIX_RETURN;
	  foreach ($keys as $key => $value) $xml .= "<$key>$value</$key>" . UNIX_RETURN;
	  $xml .= '</ewaygateway>';

	  $ch = curl_init ($eway_url);
	  curl_setopt ($ch, CURLOPT_POST, 1);
	  curl_setopt ($ch, CURLOPT_POSTFIELDS, $xml);
	  curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1); 
	  curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0); 
	  $request = str_replace("><",">\r<",curl_exec($ch));
	  preg_match_all('/<([^>]+)>([^<]+)/', $request, $response);
	  
	  curl_close($ch);
	  
	  $result = array();
	  for ($x=0; $x<sizeof($response[1]); $x++) {
	    if (strlen($response[2][$x]) > 2) $result[$response[1][$x]] = $response[2][$x];
	  }
	  
	  if ($result['ewayTrxnStatus'] != 'True') {
		shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode(MODULE_PAYMENT_CC_TEXT_ERROR . ' ' . $result['ewayTrxnError']), 'SSL'));
	  }
	  
	  $order->info['cc_approval'] = $result['ewayAuthCode'];
	}

	function after_process() {
	  return false;
	}

	function check() {
	  return defined('MODULE_PAYMENT_EWAY_STATUS');
	}

	function install() {
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_PAYMENT_EWAY_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('eWAY Customer ID', 'MODULE_PAYMENT_EWAY_MERCHANT_ID', '87654321', '', '6', '2', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key in ('" . implode("','", $this->keys()) . "')");
	}

	function keys() {
	  return array('MODULE_PAYMENT_EWAY_STATUS', 'MODULE_PAYMENT_EWAY_MERCHANT_ID');
	}
  }
