<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003-04, Secure.cc, Inc.

	Released under the GNU General Public License

*/

  class intellipay {
	var $code, $title, $description, $enabled;

	function intellipay() {
	  $this->code = 'intellipay';
	  $this->title = 'IntelliPay';
	  $this->shop_title = MODULE_PAYMENT_CC_TEXT_TITLE;
	  $this->description = '';
	  $this->signup = 'http://www.intellipay.com/';
	  $this->enabled = defined('MODULE_PAYMENT_INTELLIPAY_STATUS');
	  $this->recommend_level = 5;
	  $this->version = "1.0";
	}

	function javascript_validation() {
	  return shop_draw_cc_javascript_validation($this->code);
	}

	function selection() {
	  return shop_draw_cc_input();
	}

	function pre_confirmation_check() {
	  if ($_POST['payment_selected'] == $this->code) shop_validate_cc($_POST['cc_owner'],$_POST['cc_number'], $_POST['cc_expires_month'], $_POST['cc_expires_year'], $_POST['cc_code']);
	}

	function confirmation() {
	}

	function process_button() {
	  $process_button_string = shop_draw_hidden_field('cc_owner', $_POST['cc_owner']) . 
	                           shop_draw_hidden_field('cc_number', $_POST['cc_number']) . 
	                           shop_draw_hidden_field('cc_code', $_POST['cc_code']) . UNIX_RETURN .
	                           shop_draw_hidden_field('cc_expires', $_POST['cc_expires_month'] . substr($_POST['cc_expires_year'], -2)) . UNIX_RETURN;

	  return $process_button_string;
	}
	
	function before_process() {
		global $order;
		
		$cc_type = shop_card_type($_POST['cc_number']);

		$data_array = array('LOGIN' => MODULE_PAYMENT_INTELLIPAY_LOGIN,
							'PASSWORD' => MODULE_PAYMENT_INTELLIPAY_PASSWORD,
							'INVOICE' => $order->info['orders_id'],
							'AMOUNT' => number_format($order->info['total'], 2),
							'CARDNUM' => $_POST['cc_number'],
							'EXPDATE' => $_POST['cc_expires'], //'CARDCODE' => $_POST['cc_code'],
							'TYPE' => 'NA',
							'METHOD' => $cc_type['id'],
							'RECEIPTFORMAT' => 'DelimitedList',
							'DUPECHECK' => 'N',
							'NAME' => $_POST['cc_owner'],
							'ADDRESS' => $order->customer['street_address'],
							'CITY' => $order->customer['city'],
							'REGIONCODE' => $order->customer['state'],
							'ZIP' => $order->customer['postcode'],
							'PHONE' => $order->customer['telephone'],
							'EMAIL' => $order->customer['email_address']);

		$response = http_request("https://www.intellipay.net/LinkSmart/", $data_array);
		$response_array = explode(',',trim($response));

		if ($response_array[0] != 'A') {
			switch ($response_array[0]) {
				case 'S':
					$error = "The DTS has detected a possible duplicate transaction.";
					break;
				case 'D':
					$error = "The authorizer has declined the purchase request.";
					break;
				case 'R':
					$error = "The issuer has asked that you call the Voice Authorization center.";
					break;
				case 'X':
					$error = "A data entry error of some kind has occurred";
					break;
				case 'E':
					$error = "A data entry error of some kind has occurred";
					break;
				case 'U':
					$error = "A system failure of some kind has occurred.";
					break;
				case 'F':
					$error = "A system failure of some kind has occurred.";
					break;
			}
			shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode(MODULE_PAYMENT_CC_TEXT_ERROR . ' ' . $error), 'SSL'));
		}
		$order->info['cc_approval'] = $response_array[1];
	}

	function after_process() {
	}

	function check() {
	  return defined('MODULE_PAYMENT_INTELLIPAY_STATUS');
	}

	function install() {
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_PAYMENT_INTELLIPAY_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Login Username', 'MODULE_PAYMENT_INTELLIPAY_LOGIN', 'testing', 'The login username used for the IntelliPay service', '6', '0', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Login Password', 'MODULE_PAYMENT_INTELLIPAY_PASSWORD', 'testing', 'The IntelliPay admin password', '6', '0', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_PAYMENT_INTELLIPAY_%'");
	}

	function keys() {
	  return array('MODULE_PAYMENT_INTELLIPAY_STATUS', 'MODULE_PAYMENT_INTELLIPAY_LOGIN', 'MODULE_PAYMENT_INTELLIPAY_PASSWORD');
	}
  }
  

function shop_card_type($cc_number) {
	$card_types = array('AX' => ereg("^3[47].{13}$", $cc_number),
						'DL' => ereg("^4.{15}$", $cc_number),
						'DI' => ereg("^30[0-5].{11}$|^3[68].{12}$", $cc_number),
						'NO' => ereg("^6011.{12}$", $cc_number),
						'ER' => ereg("^2014.{11}$|^2149.{11}$", $cc_number),
						'JC' => ereg("^3.{15}$|^2131|1800.{11}$", $cc_number),
						'SW' => ereg("^[456].{15}$|^[456].{17,18}$", $cc_number),
						'VI' => ereg("^4.{15}$|^4.{12}$", $cc_number),
						'MC' => ereg("^5[1-5].{14}$", $cc_number));
	
	$card_names = array('AX' => 'American Express',
						'DL' => 'Delta',
						'DI' => 'Diners Club',
						'NO' => 'Discover Card',
						'ER' => 'EnRoute',
						'JC' => 'JCB',
						'SW' => 'Switch',
						'VI' => 'Visa',
						'MC' => 'MasterCard');
    $card_type = null;
	foreach($card_types as $card_type=>$match) if ($match == 1) $cc_type = $card_type;

	return array('id' => $cc_type, 'name' => $card_names[$cc_type]);
}
