<?php
/*

  eShox 4 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003-04, Secure.cc, Inc. All rights reserved.

  SOFTWARE LICENSE INFORMATION

  http://www.eshox.com/license.html

  PLEASE READ THE SECURE.CC, INC. SINGLE USE SOFTWARE LICENSE AGREEMENT (HEREIN, THE "LICENSE") 
  CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY INSTALLING OR USING THE 
  SOFTWARE, YOU ARE AGREEING TO BE BOUND BY THE TERMS OF THE LICENSE.

*/

class fedex {
	var $code, $title, $description, $icon, $enabled, $recommend_level, $version, $quote;

	function fedex() {
		$this->code = 'fedex';
		$this->title = 'FedEx';
		$this->shop_title = 'FedEx';
		$this->description = 'FedEx Shipping Options:';
		$this->icon = 'images/shipping/shipping_fedex.gif';
		$this->enabled = defined('MODULE_SHIPPING_FEDEX_STATUS');
		$this->recommend_level = 5;
		$this->version = "3.5";
		$this->quote = array();
		$this->account_number = ereg_replace('[^0-9]+', '', MODULE_SHIPPING_FEDEX_ACCOUNT_NUMBER);
	}

  function fedex_connect($raw = false) {
    foreach ( $this->query_array as $key => $val ) { $this->rate_query .= "$key,\"$val\""; }
    $ch = curl_init();
    curl_setopt ($ch, CURLOPT_URL, 'https://gateway.fedex.com/GatewayDC');
    curl_setopt ($ch, CURLOPT_POSTFIELDS, $this -> rate_query);
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
    $this->in = $this->rate_query;
    if (!$raw) {
    	$this->out = split('[,\"]', curl_exec($ch));
    	for ($x=0; $x<sizeof($this->out); $x+=3) if ($this->out[$x] && $this->out[$x+2]) $this->result[$this->out[$x]] = $this->out[$x+2];
    }
    else $this->result = curl_exec($ch);
    return $this->result;
  }
  
  function fedex_meter() {
    $this->query_array = array(0 => "211",
                               10 => $this->account_number,
                               4003 => STORE_NAME,
                               4007 => STORE_NAME,
                               4008 => STORE_NAME_ADDRESS,
                               4011 => STORE_CITY,
                               4012 => STORE_ST,
                               4013 => substr(STORE_ORIGIN_ZIP,0,5),
                               4014 => STORE_COUNTRY_CODE,
                               4015 => '1231231234',
                               99 => "");
  }

  function fedex_query($weight, $destZip, $destCountry, $originZip, $originCountry, $destState, $originState) {
		$this->query_array = array('0'=>'025',
						 '10' => $this->account_number,
						 '498' => $this->meter,
						 '9' => $originZip,
						 '8' => $originState,
						 '117' => $originCountry,
						 '17' => $destZip,
						 '16' => $destState,
						 '50' => $destCountry,
						 '1401' => number_format($weight,1),
						 '75' => 'LBS');
  }

	function quote() {
		global $shipping_weight, $shipping_num_boxes, $address_values;

		if (MODULE_SHIPPING_FEDEX_MN == '') {
			$this->fedex_meter();
			$query = $this->fedex_connect();
			if ($query['498']) {
		  	shop_db_query("update " . DB_PREFIX . "configuration set configuration_value = '" . $query['498'] . "' where configuration_key = 'MODULE_SHIPPING_FEDEX_MN'");
		  	$this->meter = $query['498'];
			}
		}
		else $this->meter = MODULE_SHIPPING_FEDEX_MN;
		
		$this->fedex_query(number_format($shipping_weight,1), substr($address_values['postcode'],0,5), $address_values['country_code'], substr(STORE_ORIGIN_ZIP,0,5), STORE_COUNTRY_CODE, $address_values['st'], STORE_ST);

		$query = $this->fedex_connect(true);
		preg_replace('/([0-9]{1,4})[-]{0,1}([0-9]{1,2}){0,1},"([^"]+)"/e','$result_array[\\2][\\1]="\\3"', $query);
		$products = array('01'=>'1DP','03'=>'2DA','05'=>'1DA','06'=>'1FS','20'=>'3DA','70'=>'1DF','80'=>'2DF','83'=>'3DF','90'=>'FHD','92'=>'GDS');
		if ($address_values['country_code'] != 'US') $products = array('01'=>'IPR','03'=>'IEC','06'=>'IFS','70'=>'IPF','86'=>'IEF');
		
		$shipping_fedex_cost = 9999;
		$rates = array();

		foreach ($result_array as $id => $values) {
			$code = $values[1274];
			$total = $values[1419];
			if ($values[3]) $errors .= $values[3];
			if ($total > 0) {
				if (constant('MODULE_SHIPPING_FEDEX_'.$products[$code]) == 'true') {
					$total = $total + ($total * (SHIPPING_MARK/100));
					$total = (SHIPPING_HANDLING_TOTAL + $total) * $shipping_num_boxes;
					if ($total < $shipping_fedex_cost) $shipping_fedex_cost = $total;
					$this->quote[$total] = array('Method' => 'FedEx ' . $products[$code], 'Service' => $this->display($products[$code]), 'TotalCharges' => $total);
				}
			}
		}
		krsort($this->quote);
		
		return $shipping_fedex_cost;
	}

	
	function display($code = false) {
		$products = array('1DP'=>'Priority Overnight&reg;',
						  '1DA'=>'Standard Overnight&reg;',
						  '1FS'=>'First Overnight&reg;',
						  '2DA'=>'2Day&reg;',
						  '3DA'=>'Express Saver&reg;',
						  '1DF'=>'1day&#8480; Freight',
						  '2DF'=>'2day Freight&reg;',
						  '3DF'=>'3day&#8480; Freight',
						  'FXT'=>'Domestic Freight',
						  'IPR'=>'International Priority&reg;',
						  'IEC'=>'International Economy&reg;',
						  'IFS'=>'International First&reg;',
						  'IPF'=>'International Priority&reg; Freight',
						  'IEF'=>'International Economy&reg; Freight',
						  'FHD'=>'Home Delivery',
						  'GDS'=>'Ground Service');

		if ($code) return $products[$code];
		return $products;
	}

	function check() {
	  return defined('MODULE_SHIPPING_FEDEX_STATUS');
	}

	function install() {
		shop_db_perform('configuration', array('configuration_key'=>'MODULE_SHIPPING_FEDEX_STATUS','configuration_value'=>'true'), 'insert');
		shop_db_perform('configuration', array('configuration_title'=>'FedEx Account Number','configuration_key'=>'MODULE_SHIPPING_FEDEX_ACCOUNT_NUMBER','configuration_value'=>'123456789','configuration_group_id'=>'6','sort_order'=>'1'), 'insert');
		shop_db_perform('configuration', array('configuration_title'=>'FedEx Meter Number','configuration_key'=>'MODULE_SHIPPING_FEDEX_MN','configuration_value'=>'','configuration_group_id'=>'6','sort_order'=>'2'), 'insert');

		$products = $this->display();
		$i = 3;
		foreach ($products AS $code=>$name) {
			shop_db_perform('configuration', array('configuration_title'=>$name, 'configuration_key'=>'MODULE_SHIPPING_FEDEX_' . $code, 'configuration_value'=>'true', 'configuration_group_id'=>'6', 'sort_order'=>$i++, 'use_function'=> 'shop_cfg_checkbox_display(', 'set_function'=>'shop_cfg_checkbox('), 'insert');
		}
	}

	function remove() {
		shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_SHIPPING_FEDEX_%'");
	}

	function keys() {
		$products = $this->display();
		$keys = array('MODULE_SHIPPING_FEDEX_STATUS', 'MODULE_SHIPPING_FEDEX_ACCOUNT_NUMBER', 'MODULE_SHIPPING_FEDEX_MN');
		foreach ($products AS $code=>$name) $keys[] = 'MODULE_SHIPPING_FEDEX_' . $code;
		return $keys;
	}
}